// Egy rajzon n virgot fogunk kisznezni. A festkeket az 1, 2, ..., m szmokkal kdoljuk. 
// Brmely virg, brmilyen szn lehet, de szeretnnk tudni, hogyan lehetne ezeket klnbz mdon kisznezni. 
//Oldjuk meg a feladatot, ha m >= 2!

#include <iostream>
#include <string>

using namespace std;

int n, m;
int x[20];

void Kiir(){
    cout << "(" << x[1];
    for(int i = 2; i <= n; i++)
      	cout << "," << x[i]; 
    cout << ")" << endl;
}

void Descartes(int i){
// generljuk az {1, 2, ..., n}^m Descartes szorzat minden elemt

    for(int j = 1; j <= m; j++){
      	x[i] = j;
      	if(i < n) 
        	Descartes(i+1);
      	else 
        	Kiir();
    }
}

int main(){	
  	cout << "n = "; cin >> n;
  	cout << "m = "; cin >> m;  
  	Descartes(1); 
}
