/*
n^k utolsó számjegye
*/

#include <iostream>

using namespace std;

int F(int a, int b){
// iteratív algoritmus 

int c = 1;
	
	while(b > 0){
		if(b % 2 == 1) 
			c = c * a % 10; 
		
		a = a * a % 10;
        b = b / 2; 
	}
	
	return c;
}

int FRek_1(int a, int b){
// rekurzív algoritmus 

	if(b == 0)
		return 1;
	else
		if(b % 2 == 1)
			return a % 10 * FRek_1(a * a % 10, b / 2) % 10;
		else 
			return FRek_1(a * a % 10, b / 2) % 10; 
}

int FRek_2(int a, int b){
// rekurzív algoritmus 

	if(b == 0)
		return 1;
	int c = 1;
	if(b % 2 == 1)
		c = (c * a) % 10;
	a = (a * a) % 10;
	b = b / 2;
	c = c * FRek_2(a, b);
	return c;
}

int hatvany(int a, int b){
// kiszámítjuk a hatványt (ellenőrzés céljából)

int c = 1;
	
	while(b > 0){
		if(b % 2 == 1 ) 
			c = c * a; 
		
		a = a * a;
        b = b / 2; 
	}
	return c;
}

int main(){

	//int n,k;
	//cout << "n = "; cin >> n; cout << endl;
	//cout << "k = "; cin  >> k; cout << endl;
	
	for(int n = 2; n < 10; n++)
		for(int k = 0; k < 5; k++){
			cout << "n = " << n << " k = " << k << endl;
			cout << "Utolso szamjegye (iterativ algoritmussal) az " << n << "^" << k << "-nak: " << F(n,k) << endl; 
			cout << "Utolso szamjegye (az 1. rekurziv algoritmussal) az " << n << "^" << k << "-nak: " << FRek_1(n,k) << endl; 
			cout << "Utolso szamjegye (a 2. rekurziv algoritmussal) az " << n << "^" << k << "-nak: " << FRek_2(n,k) << endl; 
			
			cout << "n^k = " << n << "^" << k << " = " << hatvany(n,k) << endl << endl;
		}
	return 0;
}

