/*
	Legyen a következő alprogram, ahol n bemeneti paraméter, p és i kimeneti paraméterek 
	(n, p, i – természetes számok, 1 ≤ n ≤ 1 000 000, (0 ≤ p ≤ 1 000 000, 0 ≤ i ≤ 1 000 000):
*/

#include <iostream>
using namespace std;

void miEzIt(int n, int & paros, int & paratlan){
	
	paros = 0;
	paratlan = 0;
	int hatvanyParatlan = 1;
	int hatvanyParos = 1;
	while(n){
		if(n & 1){
			paratlan = paratlan + hatvanyParatlan * (n % 10);
			n /= 10;
			hatvanyParatlan *= 10;
		}
		else{
			paros = paros + hatvanyParos * (n % 10);
			n /= 10;
			hatvanyParos *= 10;
		}
	}
}

void miEzRek(int n, int paros, int paratlan){
int hatvanyParatlan = 1;
int hatvanyParos = 1;
int segedParos = paros;
int segedParatlan = paratlan;	

	if(n == 0){
		segedParos = 0;
		segedParatlan = 0;
		hatvanyParatlan = 1;
		hatvanyParos = 1;	
	}
	else{
		if(n & 1){
			miEzRek(n / 10, segedParos, segedParatlan + hatvanyParatlan * (n % 10));
			hatvanyParatlan *= 10;
		}
		else{
			miEzRek(n / 10, segedParos + hatvanyParos * (n % 10), segedParatlan);
			hatvanyParos *= 10;
		}
	}
	paros = segedParos;
	paratlan = segedParatlan;
}

int main(){
int n, paros, paratlan;

 	cout << "n = "; cin >> n;

 	cout << "ITERATIV" << endl;
 	miEzIt(n, paros, paratlan);
 	cout << n << " paros szamjegyeibol felepitett szam  = " << paros << endl;
 	cout << n << " paratlan szamjegyeibol felepitett szam = " << paratlan << endl;
 
 	cout << "REKURZIV" << endl;
 	miEzRek(n, paros, paratlan);
 	cout << n << " paros szamjegyeibol felepitett szam  = " << paros << endl;
 	cout << n << " paratlan szamjegyeibol felepitett szam = " << paratlan << endl;
}


