/*
Adott a k elemű s sorozat, amelynek elemei logikai (boolean) típusúak és a kiértékelés(s, k, i) 
algoritmus, ahol k és i (0 ≤ i ≤ k ≤ 100) természetes számok.
Határozzátok meg, hányszor hívja meg önmagát a kiértékelés(s, k, i) algoritmus a következő 
programrészlet végrehajtásának következtében:
***************
s ← (hamis, hamis, hamis, hamis, hamis, hamis, igaz, hamis, hamis, hamis) 
k ← 10 
i ← 3 
kiértékelés(s, k, i)
***************
A.	3-szor
B.	ugyanannyiszor, mint a következő programrészlet esetében 
***************
s ← (hamis, hamis, hamis, hamis, hamis, hamis, hamis, igaz) 
k ← 8 
i ← 4 
kiértékelés(s, k, i)
***************
C.	6-szor
D.	egyszer sem
E.	végtelenszer
*/

#include <iostream>

using namespace std;

int x = 0;

bool kiertekeles(bool s[], int hossz, int i){
	
	if(i <= hossz){
		if(s[i]){ 
			return s[i]; 
		}
		else{
			x++;
			return s[i] || kiertekeles(s, hossz, i + 1);
		}
	}
	else{
		return false;
	}
}

int main(){

	int k = 10;
	int i = 3;
	
	bool s[] = {false, false, false, false, false, false, true, false, false, false};
	cout << "k = " << k << " i = " << i << endl;
	bool z = kiertekeles(s, k, i);
	if(z)
		cout << "true" << endl;
	else
		cout << "false" << endl;
	cout << "Lepesek szama  = " << x << endl;

	k = 8;
	i = 4;
	
	x = 0;
	bool e[] = {false, false, false, false, false, false, false, true}; 
	cout << "k = " << k << " i = " << i << endl;
	z = kiertekeles(e, k, i);
	if(z)
		cout << "true" << endl;
	else
		cout << "false" << endl;
	cout << "Lepesek szama  = " << x << endl;
}
