/*
Adottnak tekintjük az eleme(x, a, n) algoritmust, amely eldönti, hogy az x természetes szám eleme-e 
az n elemű a halmaznak; a egy n elemű sorozat, amely egy természetes számokat tartalmazó halmazt 
ábrázol (1 ≤ n ≤ 200, 1 ≤ x ≤ 1000).
Legyen az alább megadott egyesítés(a, n, b, m, c, p) algoritmus, ahol a, b és c sorozatok, amelyek 
természetes számokat tároló és rendre n, m és p elemű halmazokat ábrázolnak (1 ≤ n ≤ 200, 1 ≤ m ≤ 200, 
1 ≤ p ≤ 400). A bemeneti paraméterek a, n, b és m, kimeneti paraméterek pedig c és p.
A következő állítások közül melyek bizonyulnak mindig igaznak?
A.	ha az a halmaz egy elemet tartalmaz, az egyesítés(a, n, b, m, c, p) algoritmus végtelen ciklusba kerül 
B.	ha az a halmaznak négy eleme van, az egyesítés(a, n, b, m, c, p) algoritmus első meghívása maga után vonja 
a 12. sorban található utasítás végrehajtását négyszer
C.	ha az a halmaznak öt eleme van, az egyesítés(a, n, b, m, c, p) algoritmus első meghívása maga után vonja 
a második sorban található utasítás végrehajtását ötször 
D.	ha az a halmaznak ugyanannyi eleme van, mint a b halmaznak, az egyesítés(a, n, b, m, c, p) algoritmus v
égrehajtása után a c halmaznak ugyanannyi eleme lesz, mint az a halmaznak 
E.	ha az a és b halmazok elemei azonosak, az egyesítés(a, n, b, m, c, p) algoritmus végrehajtása után a c 
halmaznak ugyanannyi eleme lesz, mint az a halmaznak
*/
#include <iostream>
#include <fstream>

using namespace std;

ifstream fin("egyesites.in");

int const maxDim = 100;
int xx = 0;
int xxx = 0;

void beOlvas(int &n, int x[]){
	
	fin >> n;
	for(int i = 1; i <= n; i++)
		fin >> x[i];
}

void kiIr(int n, int x[]){

	cout << "Hossz = " << n << endl;
	for(int i = 1; i <= n; i++)
		cout << x[i] << " ";
	cout << endl;
}

bool eleme(int x, int b[], int m){

	int i = 1;
	while(i <= m && x != b[i])
		i++;
	return i <= m;
}

void egyesites(int n, int a[], int m, int b[], int & p, int c[]){
	xxx++;
	if(n == 0) { 
		for(int i = 1; i <= m; i++){
			p = p + 1;
			c[p] = b[i]; 
		} 
	}
	else{ 
		if(not eleme(a[n], b, m)) { 
			p = p + 1;
			c[p] = a[n]; 
		}
		xx++;
		egyesites(n - 1, a, m, b, p, c);
	} 
}

int main(){

	int n, m, szam;
	int x[maxDim], y[maxDim], z[2*maxDim];

	for(int i = 1; i <= 5; i++){	
		beOlvas(n, x);
		beOlvas(m, y);
		switch(i){
		case 1: cout << "A. ha az a-nak egy eleme van, az algoritmus vegtelen ciklusba kerul?" << endl; break;
		case 2: cout << "B. ha az a-nak 4 eleme van, a 12. sorban talalhato utasitas 4-szer hajtodik vegre?" << endl; break;
		case 3: cout << "C. ha az a-nak 5 eleme van, a 2. sorban talalhato utasitas 5-szor hajtodik vegre?" << endl; break;
		case 4: cout << "D. ha az a-nak ugyanannyi eleme van, mint a b-nek, a c-nek ugyanannyi eleme lesz, mint az a-nak?" << endl; break;
		case 5: cout << "E. ha az a es b elemei azonosak, a c-nek ugyanannyi eleme lesz, mint az a-nak?" << endl; break;
		}
		cout << "Az x sorozat: " << endl;
		kiIr(n, x);
		cout << "Az y sorozat: " << endl;
		kiIr(m, y);
		szam = 0;
		xx = 0;
		xxx = 0;
		egyesites(n, x, m, y, szam, z);
		cout << "A z sorozat: " << endl;
		kiIr(szam, z);	
		cout << "Lepesek szama a 2. sorban = " << xxx << endl;		
		cout << "Lepesek szama a 12. sorban = " << xx << endl;
		system("PAUSE");
	}
}
	
