//rjunk rekurzv algoritmust, amely kiszmtja egy n-ed fok polinom rtkt egy adott x pontban!

#include <iostream>
#include <fstream>

using namespace std;

ifstream fin("poli.in");

void beOlvas(int & n, float a[], float & x){    // beolvasas (az egyutthatok sorrendje: legmagasabb helyertektol legalacsonyabbig)

    fin >> n;

    for(int i = 0; i <= n; i++)
        fin >> a[i];

    fin >> x;
}

void kiIr(int n, float a[], float & x){    

    cout << "n = " << n << endl;
    cout << "Egyutthatok:" << endl;
    for(int i = 0; i <= n; i++)
        cout << a[i] << " ";
    cout << endl;
    cout << "x = " << x << endl;
}

/*
float poliErtek(float a[], int i, float x){

    if(i == -1)         // ha mar nincs tobb egyutthato
        return 0;
    return poliErtek(a, i-1, x) * x + a[i];    // Horner-sema
}
*/

float poliErtekIt(float a[], int n, float x){

int p = 0;
    for(int i = 0; i <= n; i++)
        p = p * x + a[i];
    return p;
}

float poliErtekRek(float a[], int n, float x){

    if(n >= 0)         // ha mar nincs tobb egyutthato
        return poliErtekRek(a, n - 1, x) * x + a[n];
    else
        return 0;    // Horner-sema
}

int main(){
    float a[100];
    float x;
    int n;

    beOlvas(n, a, x);
    kiIr(n, a, x);
    cout << "A polinom erteke (iterativ) = " << poliErtekIt(a, n, x) << endl;
    cout << "A polinom erteke (rekurziv) = " << poliErtekRek(a, n, x) << endl;
}
