/*
Legyen az n × n méretű négyzetes mat tömb (n – páratlan természetes szám, 3 ≤ n ≤ 100). 
A tegyélB(mat, n, i, j) algoritmus 'b' betűket tesz a mat tömb bizonyos pozícióira. 
Az i és j paraméterek természetes számok (1 ≤ i ≤ n, 1 ≤ j ≤ n).
Határozzátok meg, hányszor hívja meg önmagát a tegyélB algoritmus a következő programrészlet 
végrehajtásának következtében:
********
n ← 7 
i ← 2 
j ← 4
tegyélB(mat, n, i, j)
********
A. 5-ször	

B. ugyanannyiszor, mint a következő programrészlet esetében:
***********
n ← 9, i ← 3, j ← 5
tegyélB(mat, n, i, j)
***********

C. 10-szer
D. 0-szor
E. végtelenszer
*/

#include <iostream>
#include <ctime>

using namespace std;

int const maxDim = 10;

int x = 0;

void init(int n, char mat[][maxDim]){

	for(int i = 1; i <=n; i++)
		for(int j = 1; j <= n; j++)
			mat[i][j] = 'a';
}

void kiIr(int n, char mat[][maxDim]){

	for(int i = 1; i <=n; i++){
		for(int j = 1; j <= n; j++)
			cout << mat[i][j];
		cout << endl;
	}
}

void tegyelB(char mat[][maxDim], int n, int i, int j){

	if(i <= n / 2){
		if(j <= n - i){
			mat[i][j] = 'b';
			x++;

			tegyelB(mat, n, i, j + 1);
		}
		else{
			x++;
			tegyelB(mat, n, i + 1, i + 2);
		}
	}
}

int main(){
	char mat[maxDim][maxDim];
	
	int n = 9;
	init(n, mat);
	int i = 3;
	int j = 5;
	tegyelB(mat, n, i, j);
	cout << "n = " << n << " i = " << i << " j = " << j << endl;
	kiIr(n, mat);
	cout << "Lepesek szama = " << x << endl << endl;
	
	x = 0;
	n = 7;
	init(n, mat);
	i = 2;
	j = 4;
	tegyelB(mat, 7, 2, 4);
	cout << "n = " << n << " i = " << i << " j = " << j << endl;
	kiIr(n, mat);
	cout << "Lepesek szama = " << x << endl << endl;
}