/*
Legyen a törzsTényezők(n, d, k, x) algoritmus, amely meghatározza az n természetes szám 
k darab törzstényezőjét, a törzstényezők keresését a d értéktől kezdve. Bemeneti paraméterek 
az n, d és k számok, kimeneti paraméterek az x sorozat, amely a k törzstényezőt tartalmazza 
(1 ≤ n ≤ 10000, 2 ≤ d ≤ 10000, 0 ≤ k ≤ 10000).
Határozzátok meg, hányszor hívja meg önmagát a törzsTényezők(n, d, k, x) algoritmus a következő 
programrészlet végrehajtásának következtében: 
**********
n ← 120
d ← 2
k ← 0
törzsTényezők(n, d, k, x)
**********
A. 3-szor			B. 5-ször		C. 9-szer	D. 6-szor
E. ugyanannyiszor, mint a következő programrészlet esetében:
**********
n ← 750
d ← 2
k ← 0
törzsTényezők(n, d, k, x)
**********
*/

#include <iostream>
#include <fstream>

using namespace std;

int xx;

void torzstenyezok(int n, int d, int &k, int x[]){

	if(n % d == 0) {
		k++;
		x[k] = d;		
	}
	while(n % d == 0) 
		n = n / d;

	if(n > 1) {
		torzstenyezok(n, d + 1, k, x);
		xx++;
	}
}

void kiIr(int n, int x[]){

	cout << "k = " << n << endl;
	for(int i = 1; i <= n; i++)
		cout << x[i] << " ";
	cout << endl;
}

int main(){

int x[100];

	int n = 120;
	int d = 2;
	int k = 0;
	torzstenyezok(n, d, k, x);
	cout << "n = " << n << " d = " << d << endl;
	kiIr(k, x);
	cout << "Lepesek szama = " << xx << endl << endl;

	n = 750;
	d = 2;
	k = 0;
	xx = 0;
	torzstenyezok(n, d, k, x);
	cout << "n = " << n << " d = " << d << endl;
	kiIr(k, x);
	cout << "Lepesek szama = " << xx << endl;	
}