/*
A számJegyek(n, d) algoritmus (n és d természetes számok, 10 ≤ n ≤ 100 000, 1 ≤ d ≤ 9), 
meghatározza és visszatéríti azt a legkisebb természetes számot, amelynek d-nél kisebb vagy d-vel egyenlő, 
nem nulla szám¬jegyei vannak és amely számjegyeknek a szorzata egyenlő n-nel. Például, ha n = 108 és d = 9, 
az algoritmus 269-et térít vissza. Ha ilyen szám nem létezik, az algoritmus -1-et térít. 
Állapítsátok meg, hányszor hívja meg önmagát a számJegyek(n, d) algoritmus az alábbi programrészlet 
végrehajtásának következtében:
	beOlvas n
	érték ← számJegyek(n, 9)
A.	Ha n = 108, az algoritmus 11-szer hívja meg önmagát.
B.	Ha n = 109, az algoritmus 8-szor hívja meg önmagát.
C.	Ha n = 13, az algoritmus egyszer sem hívja meg önmagát.
D.	Ha n = 100, az algoritmus 10-szer hívja meg önmagát.
*/
#include <iostream>
#include <fstream>

using namespace std;

int sz = 0;

ifstream fin("szamok.in");

void beOlvas(int & n){

	fin >> n;
}

long rek(int n, int d){

int ertek;
	if(d == 1){
		if(n == 1)
			return 0;
		else
			return -1;
	}
	else{
		if(n % d == 0){ 
			sz++;
			ertek = rek(n / d, d);
			if(ertek < 0)
				return -1;
			else
				return ertek * 10 + d;
		}
		else{
			sz++;
			return rek(n, d - 1);
		}
	}
}

int main(){
	int n, d = 9;
	for(int i = 1; i <= 4; i++){
		sz = 0;
		beOlvas(n);
		cout << "n = " << n << " d = " << d << endl;
		switch(i){
			case 1: cout << "A. az algoritmus 11-szer hivja meg onmagat?" << endl; break;
			case 2: cout << "B. az algoritmus 8-szor hivja meg onmagat?" << endl; break;
			case 3: cout << "C. az algoritmus egyszer sem hivja meg onmagat??" << endl; break;
			case 4: cout << "D. az algoritmus 10-szer hivja meg onmagat?" << endl; break;
		}
		cout << "A " << rek(n, d) << " szam szamjegyeinek szorzata = " << n << endl;
		cout << "Lepesek szama = " << sz << endl << endl;
	}
}