// Melyik alábbi algoritmus számítja ki a^b értékét?

#include <iostream>
#include <fstream>

using namespace std;

ifstream fin("hatvany.in");

int hatvany_a(int a, int b){

int eredmeny = 1;
	while(b > 0){
		if(b % 2 == 1) {
			eredmeny *= a; 
		}
		b /= 2;
		a *= a;
	}
	return eredmeny;
}

/*
int hatvany_b(int a, int b){

int eredmeny = 1;
	while(b > 0){
		if(b & 1) 
			eredmeny *= a;
		b >>= 1;
		a *= a;
	}
	return eredmeny;
}
*/
int hatvany_b(int a, int b){

	if(b){ 
		if(b % 2 == 1)
			return hatvany_b(a * a, b / 2) * a;
		else
			return hatvany_b(a * a, b / 2);
	}
	else
		return 1;
}

int hatvany_c(int a, int b){

int eredmeny = 1;
	while(b > 0) {
		eredmeny *= a;
		b--;		
	}
	return eredmeny;
}

int hatvany_d(int a, int b){

	if(b == 0) 
		return 1;

	int aux = hatvany_d(a, b / 2);
	if(b % 2 == 0) 
		return aux * aux;
	else
		return a * aux * aux;
}

int hatvany_e(int a, int b){

	if(b == 0)  
		return 1;
	return a * hatvany_e(a, b - 1);
}

int main(){
int a = 2, b = 10;

	cout << "a = " << a << " b = " << b << endl;
	cout << "a: " << hatvany_a(a, b) << endl;
	cout << "b: " << hatvany_b(a, b) << endl;
	cout << "c: " << hatvany_c(a, b) << endl;
	cout << "d: " << hatvany_d(a, b) << endl;
	cout << "e: " << hatvany_e(a, b) << endl;
}
