/*
Legyen a számolásKarakterekkel(s, n, p, q, szám) algoritmus, ahol s egy n karakterből álló sorozat 
(n természetes szám, 1 ≤ n ≤ 9), p, q és szám természetes számok (1 ≤ p ≤ n, 1 ≤ q ≤ n, p ≤ q).
Írjátok le a számolásKarakterekkel(s, n, p, q, szám) algoritmus rekurzív változatát úgy, hogy a 
fejléce és a hatása legyen azonos a fenti algoritmuséval. Az alábbi programrészletből hívjuk meg:
Beolvas: n, s, p, q
KiÍr: számolásKarakterekkel(s, n, p, q, 0)
*/

#include <iostream>
#include <fstream>
#include <string>
using namespace std;

ifstream fin("B_1.in");

void beOlvas(string & s, int & hossz){

    fin >> s;

    hossz = 0;
    while(s[hossz]){
        hossz++;
    }

	string ss = "0";    
    for(int i = 0; i < hossz; i++)
        ss = ss + s[i];
    
    s = ss;
}

void kiIr(string s, int hossz){

    cout << "Az adott karakterlanc: ";
    for(int i = 1; i <= hossz; i++){
        cout << s[i];
    }
    cout << " a hossza = " << hossz << endl;
}

int szamolasKarakerekkelIterativ(string s, int n, int p, int q, int szam){

	int eredmeny = 0;
    int i = p;
	while(i <= q){
		while(i <= q and s[i] >= '0' and s[i] <= '9') {
			szam = szam * 10 + s[i] - '0';	
			i++;
		}
		eredmeny = eredmeny + szam;			
		szam = 0;							
		i++;							
	} 
	return eredmeny;
}

int szamolasKarakerekkelRekurziv(string s, int n, int p, int q, int szam){
// determinarea si returnarea sumei numerelor cuprinse in sir 

	if(p > q) 
		return szam;
	else
		if(s[p] < '0' or s[p] > '9')  
			return szam + szamolasKarakerekkelRekurziv(s, n, p + 1, q, 0);
		else
			return szamolasKarakerekkelRekurziv(s, n, p + 1, q, 10 * szam + s[p] - '0');
}

int main(){
    string s;
	int hossz;    

    for(int i = 1; i <= 6; i++){
    	
        beOlvas(s, hossz);
        kiIr(s, hossz);
        int p = 1;
        int q = hossz;
        cout << "Szamok osszege (iterativ) = " << szamolasKarakerekkelIterativ(s, hossz, p, q, 0) << endl;
        cout << "Szamok osszege (rekurziv) = " << szamolasKarakerekkelRekurziv(s, hossz, p, q, 0) << endl;
        cout << endl;
    }
}
