/*
Egy számjegymágus olyan varázslatot végez, amelynek eredményeképpen egy x természetes szám 
(100 < x < 1 000 000, amelynek a 10-es számrendszerben van legkevesebb két 0-tól különböző számjegye) 
szétválik két pozitív természetes számra: a bal és jobb számokra, amelyek egymás után ragasztva megadják 
az x számot. Ugyanakkor a bal és jobb számok szorzata a lehető legnagyobb. Például, ha x = 1 092, a 
varázslat szétválasztja a bal = 10 és jobb = 92 számokra. 
	Az alábbi algoritmusok közül melyik alkalmazza a varázslatot az x természetes számra, amelynek 10-es 
	számrendszerben van legkevesebb két 0-tól különböző számjegye (100 ≤ x ≤ 1 000 000)? Az algoritmus 
	meghatározza a z természetes számban (0 ≤ z ≤ 1 000 000) az x szám jobb részét. Az alábbi algoritmusok léteznek:
•	hatvány(b, p) – meghatározza a bp értéket (b a p. hatványon), b, p – természetes számok 
(1 ≤ b ≤ 20, 1 ≤ p ≤ 20);
•	szjSzáma(sz) – meghatározza az sz szám (0 ≤ sz ≤ 1 000 000) számjegyeinek darabszámát;

*/
#include <iostream>

using namespace std;

int szjSzama(int szam){

int szjSz = 0;
	while(szam > 0){
		szjSz++;
		szam /= 10;
	}
	return szjSz;
}

int hatvany(int alap, int kitevo){

int eredmeny = 1;
	while(kitevo > 0){
		if(kitevo % 2 == 1)
			eredmeny *= alap;
		alap *= alap;
		kitevo /= 2;
	}
	return eredmeny; 
}

/*
int maxSzorzat(int x, int z){ 

int y, t;

	if(x > 0) {
		y = (x % 10) * hatvany(10, szjSzama(z)) + z;
		t = x / 10;
		if(x * z < t * y) {
			return maxSzorzat(t, y);
		}
		else{
			return x * z / 10;
		}
	}	
	else{
		return x * z;
	}
}
*/

int varazslat_A(int x, int z){
	
	int maxSzorzat = -1;
	int eredmeny = 0;
	while(x > 0){
		z = (x % 10) * hatvany(10, szjSzama(z)) + z;
		x = x / 10;
		if(x * z > maxSzorzat){
			maxSzorzat = x * z;
			eredmeny = z;
		}
	}
	return maxSzorzat;
}

int varazslat_B(int x, int z){

	int t = 0;
	if(x > 0){
    	int y = (x % 10) * hatvany(10, szjSzama(z)) + z;
    	t = x / 10;
    	if(x * z < y * t) {
      		return varazslat_B(y, t);// ITT fordítva
    	}
    	else
      		return t; //z;// itt
    }  	
  	else
    	return t;
}

int varazslat_C(int x, int z){

	int maxSzorzat = -1;
	int eredmeny = 0;
	while(x > 0){
		z = (x % 10) * hatvany(10, szjSzama(z)) + z;
		x = x / 10;
		if(x * z > maxSzorzat){
			maxSzorzat = x * z;
			eredmeny = z;
		}
	}
	return eredmeny;
}

int varazslat_D(int x, int z){ 

	if(x > 0) {
		int y = (x % 10) * hatvany(10, szjSzama(z)) + z;
		int t = x / 10;
		if(x * z < y * t)
			return varazslat_D(y, t);
		else
			return z;
	}	
	else
		return z;
}

int main(){
	
	int n = 1092;
	//cout << "n = " << n << endl;
	cout << "A: " << n << " jobb fele = " << varazslat_A(n, 0) << endl;
	cout << "B: " << n << " jobb fele = " << varazslat_B(n, 0) << endl;
	cout << "C: " << n << " jobb fele = " << varazslat_C(n, 0) << endl;
	cout << "D: " << n << " jobb fele = " << varazslat_D(n, 0) << endl;	
	//cout << maxSzorzat(75981, 0) << endl;	
}
