/*
Legyenek az m és n természetes számok (0 ≤ m ≤ 10, 0 ≤ n ≤ 10), valamint az Ack(m, n) algoritmus, 
amely kiszámítja az Ackermann-függvény értékét m és n esetében. 
Állapítsátok meg, hányszor hívja meg önmagát az Ack(m, n) algoritmus a következő utasítások 
végrehajtásának következtében.
**********
m ← 1, n ← 2
Ack(m, n)
**********
A.	7-szer
B.	10-szer
C.	5-ször
D.	ugyanannyiszor, mint az alábbi utasítások végrehajtásának következtében:
**********
m ← 1, n ← 3
Ack(m, n)
**********
*/
#include <iostream>

using namespace std;

int x = 0;

int Ack(int m, int n){
	if(m == 0) 
		return n + 1;
	else{
		if(m > 0 && n == 0) {
			x++;
			return Ack(m - 1, 1);
		}
		else{
			x++;
			int z = Ack(m, n - 1);
			x++;
			return Ack(m - 1, z);
		}
	}
} 

int main(){

int n = 2;
int m = 1; 
	cout << "Ack(1, 2) = " << Ack(m, n) << endl;
	cout << "A rekurziv hivasok szama = 7 vagy 10 vagy 5?" << endl; 
	cout << "Lepesek szama: " << x << endl;

	n = 3;
	m = 1; 
	x = 0;
	cout << "Ack(1, 3) = " << Ack(m, n) << endl;
	cout << "A rekurziv hivasok szama ugyanannyi, mint elobb?" << endl; 
	cout << "Lepesek szama: " << x << endl;
	return 0;
}


