/*
Legyen a különbség(a, n) algoritmus, ahol a egy n elemű (0 < n < 100) sorozat, amely egész számokat tárol. 
Az n és a mely értékeire térít az algoritmus 0-át?
A. n = 4 és a = (6, 4, 5, 5)
B. n = 4 és a = (-6, 5, 4, -7)
C. n = 8 és a = (-6, 5, -1, -4, 1, 4, -7, 6)
D. n = 8 és a = (-6, -3, 0, 1, 2, 3, -1, 4)
*/
#include <iostream>
#include <fstream>
#include <math.h>

using namespace std;

int const maxDim = 100;

ifstream fin("ertekek.in");

void beOlvas(int & n, int x[]){

    fin >> n;
    for(int i = 1; i <= n; i++)
        fin >> x[i];
}

void kiIr(int n, int x[]){
    
    cout << "n = " << n << endl;
    for(int i = 1; i <= n; i++)
        cout << x[i] << " ";    
    cout << endl;
}

int kulonbseg(int a[], int n){

	if(n == 0)  
		return 0;

	if(abs(a[n]) % 2 == 0) 
		return kulonbseg(a, n - 1) + a[n];
	else
		return kulonbseg(a, n - 1) - a[n];
}

int main(){

int n;
int a[maxDim];
	
	for(int i = 1; i <= 4; i++){
		beOlvas(n, a);
		kiIr(n, a);
		cout << kulonbseg(a, n) << endl;
	}
}