/* 
Legyen a kizárPáratlan(n) algoritmus, ahol n (1 ≤ n ≤ 100 000) természetes szám. 
Állapítsátok meg, melyik utasítást kellene a „…” helyére írni, ahhoz, hogy az algoritmus 
zárja ki az n számból a páratlan értékű számjegyeket.
A.  kizárPáratlan(n MOD 10) * 10 + n DIV 10
B.  kizárPáratlan(n) * 10 + n MOD 10
C.  kizárPáratlan(n DIV 10) * 10 + n MOD 10
D.  kizárPáratlan((n DIV 10) MOD 10) * 10
*/

#include <iostream>
#include <fstream>

using namespace std;

int kizarParatlan_A(int n){

    if(n == 0)  
        return 0;

    if(n % 2 == 1)  
        return kizarParatlan_A(n / 10);

    return kizarParatlan_A(n % 10) * 10 + n / 10;
}

int kizarParatlan_B(int n){ 

    if(n == 0)  
        return 0;

    if(n % 2 == 1)  
        return kizarParatlan_B(n / 10);

    return kizarParatlan_B(n) * 10 + n % 10;
}

int kizarParatlan_C(int n){

    if(n == 0)  
        return 0;

    if(n % 2 == 1)  
        return kizarParatlan_C(n / 10);

    return kizarParatlan_C(n / 10) * 10 + n % 10;
}

int kizarParatlan_D(int n){

    if(n == 0)  
        return 0;

    if(n % 2 == 1)  
        return kizarParatlan_D(n / 10);

    return kizarParatlan_D((n / 10) % 10) * 10;
}

int main(){
	int n = 12345;
    cout << "n = " << n << endl;

    //cout << "A. kizarParatlan(n MOD 10) * 10 + n DIV 10" << endl;    
    //cout << "Az " << n << " paros szamjegyeibol epitett szam = " << kizarParatlan_A(n) << endl<< endl;   

    //cout << "B. kizarParatlan(n) * 10 + n MOD 10" << endl;    
    //cout << "Az " << n << " paros szamjegyeibol epitett szam = " << kizarParatlan_B(n) << endl << endl;   

    cout << "C. kizarParatlan(n DIV 10) * 10 + n MOD 10" << endl;    
    cout << "Az " << n << " paros szamjegyeibol epitett szam = " << kizarParatlan_C(n) << endl << endl;   

    cout << "D. kizarParatlan((n DIV 10) MOD 10) * 10" << endl;    
    cout << "Az " << n << " paros szamjegyeibol epitett szam = " << kizarParatlan_D(n) << endl << endl;   
}
